require 'settings.ini'
textColor = Color.new(255, 255, 255)
smallFont = Font.createProportional()
smallFont:setPixelSizes(0, 10)
bigFont = Font.createProportional()
bigFont:setPixelSizes(0, 12)
errFont = Font.createProportional()
errFont:setPixelSizes(0, 24)
CONNECTION_TIMEOUT = 5000
DATA_TIMEOUT = 15000
MEDIA_DIR = "media\\"
THUMBS_DIR = "thumbs\\"
PLAYLIST_DIR = "playlists\\"
XBMC_PLAY = "playfile"
XBMC_PLAY_PARAM = "%s"
XBMC_STOP = "stop"
XBMC_STOP_PARAM = ""
ERR_COULD_NOT_CONNECT =     "Could not connect to \"%s\".\n\n" ..
                            "Please check:\n" ..
                            "-That the wlan switch is in position \"on\".\n" ..
                            "-That \"%s\" is properly configured."
ERR_NO_CONNECTIONS_FOUND =  "No network connections found.\n\n" ..
                            "Quit the program and create a connection.\n\n" ..
                            "Note. If you have one or more connections configured,\n" ..
                            "and still can see this message, the only solution for\n" ..
                            "now is to delete and recreate the connections. This\n" ..
                            "seems to be a bug with LUA's network\n" ..
                            "enumeration."
ERR_TIMEOUT_CONNECTING =    "Timeout connecting to %s, port %s\n\n" ..
                            "Please check:\n" ..
                            "-The the address and port number of the xbox.\n" ..
                            "-That the xbox's web server is enabled.\n" ..
                            "-That XBMC is running.\n" ..
                            "-That the xbox is turned on."
ERR_TIMEOUT_DATA =          "Timeout while receiving data.\n\n" ..
                            "If you are streaming from internet, this could be due\n" ..
                            "to a a slow line."
ERR_UNAUTHORIZED =          "Unauthorized: Logon Failed.\n\n" ..
                            "The credentials passed to the server do not match\n" ..
                            "the credentials required to log in. Please check\n" ..
                            "your settings."
ERR_NO_LOCATION =           "The specified path does not exist.\n\n" ..
                            "...%s"
ERR_UNKNOWN_COMMAND =       "Unknown command: \"%s\".\n\n" ..
                            "Your version of XBMC is probably to old. You need\n" ..
                            "a release from 2006."
background = { activeControl,
               image }
buttons = { active = browsebtns,
            aImage,
            iImage,
            tImage,
            cImage }
browsebtns = { count = 4,
            lines = 4,
            active = 0,
            topItem = 0,
            look = buttons,
            captions = {"Sort by: Name", "Playlist", "Play DVD", ""} }
SORT_BTN = 0
PLAYLIST_BTN = 1
PLAYDVD_BTN = 2
SHUTDOWN_BTN = 3
browsebtns.captions[4] = "Shutdown"
cap_num = 1
playlistbtns = { count = 4,
            lines = 4,
            active = 0,
            topItem = 0,
            look = buttons,
            captions = {"Randomize", "Load", "Save", "Clear"} }
RANDOMIZE_BTN = 0
LOAD_BTN = 1
SAVE_BTN = 2
CLEAR_BNT = 3
itemList = { count = 0,
             lines = 11,
             active = 0,
             topItem = 0,
             sortAsc = true,
             folderImg,
             audioImg,
             aImage,
             stateList = { t = 0, b, p, n, s = {} },
             idx,
             scroll = 0,
             scrollLength,
             scrollImage = Image.createEmpty(512, 12),
             tmpImg = { },
             items =  { } }
networkConnections = { count = 0,
                       lines = 4,
                       active = 0,
                       topItem = 0,
                       bgImage,
                       aImage,
                       items =  { } }
currentlyPlaying =  {scroll = 0,
                     co = nil,
                     playSpeed = 1,
                     scrollWait = 0,
                     scrollImage = Image.createEmpty(120, 10),
                     defaultImage,
                     imageName,
                     image,
                     time = Timer.new(),
                     duration = 4000,
                     values = { } }
playQueue = { count = 0,
              co = nil,
              current = nil,
              items = { } }
playList = { count = 0,
             active = false,
             randomized = false,
             items = { } }
playLists = { count = 0,
              lines = 5,
              active = 0,
              topItem = 0,
              items =  { } }
remoteControl = { selectet = nil,
                  image,
                  wImage,
                  bImage }
errorDialog = { msg = nil,
		        image }
flexrecall = 0
flex = 0
music = 0
pictures = 1
video = 2
data = "music"
switch = 0
sector = 1
function splitString(str, de)
	first = true
	parts = {}
	if de == ";" then
		str = string.gsub(str,";;","@$&")
	end
	while true do
		s, e = string.find(str,de)
		if e then
			if not (first and string.sub(str,1,s-1) == "") then
				tmp = string.sub(str,1,s-1)
				if de == ";" then
					tmp = string.gsub(tmp,"@$&",";;")
				end
				table.insert(parts,tmp)
			end
			str = string.sub(str,e+1)
			s = 1
			first = false
		else
			tmp = string.sub(str,1)
			if de == ";" then
				tmp = string.gsub(tmp,"@$&",";;")
			end
			table.insert(parts,tmp)
			break
		end
	end
	return parts
end
function split2(str,del)
	local t = {n = 0}
	local function helper(line) table.insert(t, line) end
	helper((string.gsub(str, "(.-)"..del, helper)))
	return t
end
function fileExists(path)
	file = io.open(path, "rb")
	if file then
		file:close()
		return true
	else
		return false
	end
end
function extractFileNameSMB(path)
	return string.gsub(path,"(.*/)([^/]+)$","%2")
end
function extractFileName2(path)
	return string.gsub(path,"(.*\\)([^\\]+)$","%2")
end
function rshift(x,n)
	return math.floor(x / math.pow(2, n))
end
function lshift(x,n)
	return x * math.pow(2, n)
end
function encodeB64(str)
	local B64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	local out = ""
	local sl = string.len(str)
	for i = 0, math.ceil(sl/3)-1 do
		k = i*3
		n1 = rshift(string.byte(str,1+k),2)+1
		n2 = (lshift(string.byte(str,1+k),4) & 0x30) + 1
		n3 = 65
		n4 = 65
		if sl >= 2+k then
			n2 = n2 + (rshift(string.byte(str,2+k),4) & 0x0F)
			n3 = (lshift(string.byte(str,2+k),2) & 0x3C) + 1
			if sl >= 3+k then
				n3 = n3 + (rshift(string.byte(str,3+k),6) & 0x03)
				n4 = string.byte(str,3+k) & 0x3F + 1
			end
		end
	out = out .. string.sub(B64,n1,n1) .. string.sub(B64,n2,n2) .. string.sub(B64,n3,n3) .. string.sub(B64,n4,n4)
	end
	return out
end
function decodeB64(str)
	local B64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	local out = ""
	for i = 0, math.ceil(string.len(str)/4)-1 do
		k = i*4
		out = out .. string.char(lshift(string.find(B64,string.sub(str,1+k,1+k))-1,2) + rshift((string.find(B64,string.sub(str,2+k,2+k))-1) & 0x30,4))
		if string.sub(str,3+k,3+k) ~= "=" then
			out = out .. string.char(lshift((string.find(B64,string.sub(str,2+k,2+k))-1) & 0x0F,4) + rshift((string.find(B64,string.sub(str,3+k,3+k))-1) & 0x3C,2))
		end
		if string.sub(str,4+k,4+k) ~= "=" then
			out = out .. string.char(lshift((string.find(B64,string.sub(str,3+k,3+k))-1) & 0x03,6) + ((string.find(B64,string.sub(str,4+k,4+k))-1) & 0x3F))
		end
	end
	return out
end
function timeToMilliseconds(timeStr)
	timeList = splitString(timeStr,":")
	time = 0
	for i = 0, table.getn(timeList)-1 do
		time = time + timeList[table.getn(timeList)-i] * math.pow(60,i)
	end
	return time*1000
end
function millisecondsToTime(time)
	time = math.floor(time/1000)
	hour = math.floor(time/3600)
	min =  math.floor((time-(hour*3600))/60)
	sec =  time-(hour*3600)-(min*60)
		if hour > 0 then
			str = string.format("%.2d:",hour)
		else
			str = ""
		end
	return str .. string.format("%.2d:",min) .. string.format("%.2d",sec)
end
function scaleImage(newX, newY, theImage)
	-- created by arrggg of ps2dev forum
	newImage = Image.createEmpty(newX, newY)
	for x = 1, newX do
		for y = 1, newY do
			newImage:blit(x,y , theImage, math.floor(x*(theImage:width()/newX)),math.floor(y*(theImage:height()/newY)), 1, 1)
		end
	end
	return newImage
end
function scaleImageBi(nWidth, nHeight, bTemp)
	-- by Christian Graus
	b = Image.createEmpty(nWidth, nHeight)
	nXFactor = bTemp:width()/nWidth
	nYFactor = bTemp:height()/nHeight
	local fraction_x, fraction_y, one_minus_x, one_minus_y
	local ceil_x, ceil_y, floor_x, floor_y
	local c1, c2, c3, c4
	local red, green, blue
	local b1, b2
	local x, y
	for x = 0, b:width()-1 do
		for y = 0, b:height()-1 do
			floor_x = math.floor(x * nXFactor)
			floor_y = math.floor(y * nYFactor)
			ceil_x = floor_x + 1
				if ceil_x >= bTemp:width() then
					ceil_x = floor_x
				end
			ceil_y = floor_y + 1
			if ceil_y >= bTemp:height() then
				ceil_y = floor_y
			end
			fraction_x = x * nXFactor - floor_x
			fraction_y = y * nYFactor - floor_y
			one_minus_x = 1 - fraction_x
			one_minus_y = 1 - fraction_y
			c1 = bTemp:pixel(floor_x, floor_y)
			c2 = bTemp:pixel(ceil_x, floor_y)
			c3 = bTemp:pixel(floor_x, ceil_y)
			c4 = bTemp:pixel(ceil_x, ceil_y)
			b1 = one_minus_x * c1:colors().b + fraction_x * c2:colors().b
			b2 = one_minus_x * c3:colors().b + fraction_x * c4:colors().b
			blue = one_minus_y * b1 + fraction_y * b2
			b1 = one_minus_x * c1:colors().g + fraction_x * c2:colors().g
			b2 = one_minus_x * c3:colors().g + fraction_x * c4:colors().g
			green = one_minus_y * b1 + fraction_y * b2
			b1 = one_minus_x * c1:colors().r + fraction_x * c2:colors().r
			b2 = one_minus_x * c3:colors().r + fraction_x * c4:colors().r
			red = one_minus_y * b1 + fraction_y * b2
			b:pixel(x, y, Color.new(red, green, blue))
		end
	end
	return b
end
function sortItemList(n, t)
	if not playList.active then
		if itemList.sortAsc then
			table.sort(itemList.items, function(a,b) if (a.isDir and b.isDir) or ((not a.isDir) and (not b.isDir)) then return (string.lower(a.name) < string.lower(b.name)) else return a.isDir end end)
		else
			table.sort(itemList.items, function(a,b) if (a.isDir and b.isDir) or ((not a.isDir) and (not b.isDir)) then return (string.lower(a.name) > string.lower(b.name)) else return a.isDir end end)
		end
	end
	itemList.active = 0
	for i=0, itemList.count-1 do
		if itemList.items[i+1].name == n then
			itemList.active = i
			break
		end
	end
	itemList.topItem = itemList.active-t
	if itemList.topItem  > (itemList.count - itemList.lines) then
		itemList.topItem = (itemList.count - itemList.lines)
	end
	if itemList.topItem < 0 then
		itemList.topItem = 0
	end
	freeTmpImages()
end
function moveActive(list, step)
	list.active = math.mod(list.active+list.count+step,list.count)
	if (list.active > list.topItem+(list.lines-1)) or (list.active < list.topItem) then
		list.topItem = math.mod(list.topItem+list.count-(list.lines-1)+step, list.count-(list.lines-1))
	end
end
function getTmpImage(idx)
	free = nil
	match = nil
	for i = 1, itemList.lines do
		if (not free) and ((not itemList.tmpImg[i].idx) or (itemList.tmpImg[i].idx < itemList.topItem+1) or (itemList.tmpImg[i].idx > itemList.topItem+itemList.lines)) then
			free = i
		elseif itemList.tmpImg[i].idx == idx then
			match = i
		end
	end
	return match, free
end
function freeTmpImages()
	for i = 1, itemList.lines do
		itemList.tmpImg[i].idx = nil
	end
	itemList.idx = nil
end
function corutineHandler()
	if playQueue.co and coroutine.status(playQueue.co) ~= 'dead' then
		coroutine.resume(playQueue.co)
	end
	if currentlyPlaying.co and coroutine.status(currentlyPlaying.co) ~= 'dead' then
		coroutine.resume(currentlyPlaying.co)
	end
end
function getAlbumArt(path)
	imageName = string.lower(string.gsub(extractFileName2(path),";;",";"))
	imageName = string.gsub(imageName, ".tbn", "")
	if imageName ~= currentlyPlaying.imageName then
		currentlyPlaying.imageName = imageName
		if fileExists(THUMBS_DIR .. currentlyPlaying.imageName .. ".png") then
			currentlyPlaying.image = Image.load(THUMBS_DIR .. currentlyPlaying.imageName .. ".png")
		else
			currentlyPlaying.image = nil
			currentlyPlaying.co = coroutine.create(downloadAlbumArtCo)
		end
	end
end
function downloadAlbumArtCo()
	content = XbmcAlbumArtDownload()
	if content then
		if string.find(content,"iVBOR") then
			ext = "png"
		else ext = "jpg"
		end
	file = io.open(THUMBS_DIR .. "temp." .. ext, "wb")
		if file then
			file:write(decodeB64(content))
			file:close()
		end
	currentlyPlaying.image = scaleImage(75,75,Image.load(THUMBS_DIR .. "temp." .. ext))
	currentlyPlaying.image:save(THUMBS_DIR .. currentlyPlaying.imageName .. ".png")
	end
end
function setPlaySpeed(x)
	if currentlyPlaying.values["Type"] == "Audio" or currentlyPlaying.values["Type"] == "Video" then
		if x <= -120 then
			playSpeed = -10
		elseif x <= -80 and x > 120 then
			playSpeed = -5
		elseif x <= -30 and x > -80 then
			playSpeed = -3
		elseif x > -30 and x < 30 then
			playSpeed = 1
		elseif x >=30 and x < 80 then
			playSpeed = 3
		elseif x >= 80 and x < 120 then
			playSpeed = 5
		elseif x >= 120 then
			playSpeed = 10
		end
		if playSpeed ~= currentlyPlaying.playSpeed then
			currentlyPlaying.playSpeed = playSpeed
			XbmcHttpApi("setplayspeed",playSpeed)
				if playSpeed == 1 then
					XbmcGetCurrentlyPlaying()
				end
		end
		if playSpeed ~= 1 then
			sector = 1
			currentlyPlaying.scrollWait = 0
			XbmcGetCurrentlyPlaying()
		end
	else
		currentlyPlaying.playSpeed = 1
	end
end
function connectToWlan()
	for i = 1, 3 do
		if Wlan.useConnectionConfig(networkConnections.items[networkConnections.active+1].idx + 1) then
			ipAddress = Wlan.getIPAddress()
			if ipAddress then
				return true
			end
		end
	end
	errorDialog.msg = string.format(ERR_COULD_NOT_CONNECT, networkConnections.items[networkConnections.active+1].name, networkConnections.items[networkConnections.active+1].name)
	return false
end
function setPlayQueueCurrent(path)
	playQueue.current = nil
	if path then
		for i = 1, playQueue.count do
			if string.lower(string.gsub(playQueue.items[i],";;",";")) == string.lower(string.gsub(path,";;",";")) then
				playQueue.current = i-1
				break
			end
		end
	end
end
function playNext()
	local idx
	if playQueue.current then
		idx = math.mod(playQueue.current+playQueue.count+1,playQueue.count)
		if XbmcHttpApi(XBMC_STOP,XBMC_STOP_PARAM) then
			if XbmcHttpApi(XBMC_PLAY,string.format(XBMC_PLAY_PARAM,playQueue.items[idx+1])) then
				sector = 1
				currentlyPlaying.scrollWait = 0
				XbmcGetCurrentlyPlaying()
				playQueue.co = coroutine.create(XbmcFillPlayQueueCo)
			end
		end
	end
end
function playPrev()
	local idx
	if playQueue.current then
		idx = math.mod(playQueue.current+playQueue.count-1,playQueue.count)
		if XbmcHttpApi(XBMC_STOP,XBMC_STOP_PARAM) then
			if XbmcHttpApi(XBMC_PLAY,string.format(XBMC_PLAY_PARAM,playQueue.items[idx+1])) then
				sector = 1
				currentlyPlaying.scrollWait = 0
				XbmcGetCurrentlyPlaying()
				playQueue.co = coroutine.create(XbmcFillPlayQueueCo)
			end
		end
	end
end
function XbmcFillPlayQueueCo()
	local i,j
	for i = 1, 85 do
		coroutine.yield()
	end
	if not XbmcHttpApi("setcurrentplaylist","1",true) then
		return
	end
	if not XbmcHttpApi("clearplaylist","1",true) then
		return
	end
	j = playQueue.current
	for i = 1, playQueue.count-1 do
		j = math.mod(j+1,playQueue.count)
		if not XbmcHttpApi("addtoplaylist",playQueue.items[j+1],true) then
			return
		end
	end
end
function getPlayList()
	local str = ""
		for i=1, playList.count do
			str = str .. "<li>" .. playList.items[i] .. ";0"
		end
	return str
end
function addToPlayList(itemListItem)
	if not itemListItem.isDir then
		playList.count = playList.count +1
		playList.items[playList.count] = itemListItem.name .. ";" .. itemListItem.path
		System.sleep(200)
	else
		content = XbmcHttpApi("getmedialocation" , data .. ";" .. itemListItem.path)
		if content then
			values = splitString(content,"<li>")
			for key, value in values do
				if (value ~= "") and (splitString(value,";")[3] == "0")then
					playList.count = playList.count +1
					playList.items[playList.count] = splitString(value,";")[1] .. ";" .. splitString(value,";")[2]
				end
			end
		end
	end
end
function deleteFromPlayList(idx)
	local t, a
	playList.count = playList.count - 1
		for i=idx+1, playList.count do
			playList.items[i] = playList.items[i+1]
		end
	t = itemList.topItem
	a = itemList.active
	XbmcGetMedialocation("playlist")
	itemList.topItem = t
	if a >= playList.count then
		itemList.active = a -1
	else
		itemList.active = a
	end
	if itemList.topItest(itemListItem)
	if not itemListItem.isDir then
		playList.count = playList.count +1
		playList.items[playList.count] = itemListItem.name .. ";" .. itemListItem.end
function enumePlayLists()
	local i, fname
	for i=1, NUMBER_OF_PLAYLISTS do
		fname = PLAYLIST_DIR .. string.format("playlist%.2d.m3u",i)
		if fileExists(fname) then
			playLists.items[i] = {name = string.format("Playlist number %.2d", i), filename = fname }
		else
			playLists.items[i] = {name = "[empty playlist slot]", filename = fname }
		end
		playLists.count = i
	end
	background.activeControl = playLists
end
function loadPlayList(filename)
	file = io.open(filename, "r")
	if file then
		playList.count = 0
			for line in file:lines() do
				playList.count = playList.count +1
				playList.items[playList.count] = line
			end
		file:close()
	else
		playList.count = 0
	end
	XbmcGetMedialocation("playlist")
	itemList.topItem = 0
	itemList.active = 0
end
function savePlayList(filename)
	if playList.count > 0 then
		file = io.open(filename, "w")
		if file then
			for i=1, playList.count do
				file:write(playList.items[i],"\n")
			end
		file:close()
		end
	else
		System.removeFile(filename)
	end
end
function clearPlayList()
	playList.count = 0
	XbmcGetMedialocation("playlist")
end
function flextype()
	if flex > 2 then
		flex = 0
	end
	if flex == music then
		XBMC_PLAY = "playfile"
		data = "music"
		XbmcGetMedialocation("")
	elseif flex == pictures then
		XBMC_PLAY = "ShowPicture"
		data = "pictures"
		XbmcGetMedialocation("")
	elseif flex == video then
		XBMC_PLAY = "playfile"
		data = "video"
		XbmcGetMedialocation("")
	end
	if errorDialog.msg then
		flex = flexrecall
	end
end
function XbmcAlbumArtDownload()
	content = XbmcHttpApi("filedownload" , currentlyPlaying.values["Thumb"] , true)
	if content == "" then
			content = nil
	end
	return content
end
function XbmcGetCurrentlyPlaying()
	content = XbmcHttpApi("getcurrentlyplaying")
	currentlyPlaying.values = { }
	if content then
		values = splitString(content,"<li>")
		for key, value in values do
			s,e = string.find(value,":")
			if s then
				currentlyPlaying.values[string.sub(value,1,s-1)] = string.sub(value,e+1)
			end
		end
		if currentlyPlaying.values["Time"] and currentlyPlaying.values["Type"] then
			currentlyPlaying.time:reset(timeToMilliseconds(currentlyPlaying.values["Time"]))
			if currentlyPlaying.values["Duration"] then
				currentlyPlaying.duration = timeToMilliseconds(currentlyPlaying.values["Duration"])
			end
		end
		if (currentlyPlaying.values["PlayStatus"] == "Playing") then
			currentlyPlaying.time:start()
		else
			currentlyPlaying.time:stop()
		end
		if currentlyPlaying.values["Type"] then
			setPlayQueueCurrent(currentlyPlaying.values["Filename"])
			getAlbumArt(currentlyPlaying.values["Thumb"])
		else
		setPlayQueueCurrent(nil)
		end
	end
end
function setVolume(y)
	currentVolume = math.abs(splitString(XbmcHttpApi("getvolume"),"<li>")[1])
	if y <= -30 and currentVolume < 100 then
		newVolume = currentVolume +5
			if newVolume > 100 then
				newVolume = 100
			end
		elseif y >= 30 and currentVolume >= 0 then
			newVolume = currentVolume -5
			if newVolume < 0 then
				newVolume = 0
			end
	end
	XbmcSetVolume(newVolume)
	currentVolume = newVolume
end
function XbmcSetVolume(level)
	XbmcHttpApi("setvolume",level)
end
function XbmcGetMedialocation(path)
	if path then
		goingDown = true
	else
		if itemList.stateList.b and itemList.stateList.b.p then
			path = itemList.stateList.b.p
			goingDown = false
		else
			return nil
		end
	end
	if path == "playlist" then
		content = getPlayList()
		playList.active = true
	else
		content = XbmcHttpApi("getmedialocation" , data .. ";" .. path)
		playList.active = false
	end
	if content then
		values = splitString(content,"<li>")
		if itemList.count > 0 then
			n = itemList.items[itemList.active+1].name
		end
		for key, value in values do
			if value ~= "" then
				item = { name, path, isDir }
				item.name = splitString(value,";")[1]
				item.path = splitString(value,";")[2]
				item.isDir = (splitString(value,";")[3] == "1")
				itemList.items[key] = item
				itemList.count = key
			else
				itemList.count = 0
			end
		end
		itemList.items[itemList.count+1] = nil
		itemList.stateList.t = itemList.active-itemList.topItem
		itemList.stateList.n = n
		if goingDown then
			if playList.active then
				if playList.stateList == itemList.stateList then
					playList.stateList.t = 0
				else
					if not playList.stateList then
						playList.stateList = { t = 0, b, n="" }
					end
					playList.stateList.b = itemList.stateList
					itemList.stateList = playList.stateList
				end
			else
				if not itemList.stateList.s[path] then
					itemList.stateList.s[path] = { t = 0, b, p = path, n="", s = {} }
					itemList.stateList.s[path].b = itemList.stateList
				end
				itemList.stateList = itemList.stateList.s[path]
			end
		else
			itemList.stateList = itemList.stateList.b
		end
		sortItemList(itemList.stateList.n, itemList.stateList.t)
	end
	return content
end
function Xbmcplaydvd()
	XbmcHttpApi("playfile","D:\\VIDEO_TS\\VIDEO_TS.IFO",false,false)
	sector = 1
	currentlyPlaying.scrollWait = 0
	XbmcGetCurrentlyPlaying()
	if DVDRC and (currentlyPlaying.values["Title"] == "VIDEO_TS.IFO") then
		background.activeControl = remoteControl
	end
end
function XbmcPlayFile()
	if XbmcHttpApi(XBMC_STOP,XBMC_STOP_PARAM) then
		if XbmcHttpApi(XBMC_PLAY,string.format(XBMC_PLAY_PARAM,itemList.items[itemList.active+1].path)) then
			playQueue.count = 0
			for i = 1, itemList.count do
				if not itemList.items[i].isDir then
					playQueue.count = playQueue.count + 1
					playQueue.items[playQueue.count] = itemList.items[i].path
				end
			end
		if playList.active and playList.randomized then
			local tmpValue
			for i = 1, itemList.count-1 do
				j = math.random(i, itemList.count)
				tmpValue = playQueue.items[i]
				playQueue.items[i] = playQueue.items[j]
				playQueue.items[j] = tmpValue
			end
		end
		sector = 1
		currentlyPlaying.scrollWait = 0
		XbmcGetCurrentlyPlaying()
		playQueue.co = coroutine.create(XbmcFillPlayQueueCo)
		end
	end
end
function XbmcStopPlaying()
	if XbmcHttpApi(XBMC_STOP,XBMC_STOP_PARAM) then
		sector = 1
		currentlyPlaying.scrollWait = 0
		XbmcGetCurrentlyPlaying()
		playQueue.co = nil
	end
end
function XbmcPausePlaying()
	if XbmcHttpApi("pause") then
		XbmcGetCurrentlyPlaying()
	end
end
function XbmcSendKey(key)
	XbmcHttpApi("sendkey",key,false,true)
end
function XbmcHttpApi(command, parameters, yield, nowait)
	local socket, error, timeout, buffer, tmp, params
	socket, error = Socket.connect(XBOX_IP_ADDRESS, XBOX_SERVER_PORT)
	if error == 125 then
		if connectToWlan() then
			socket, aerror = Socket.connect(XBOX_IP_ADDRESS, XBOX_SERVER_PORT)
		else
			return nil
		end
	end
	timeout = 0
	while not socket:isConnected() do
		if yield then
			 coroutine.yield()
		else
			System.sleep(1)
		end
		timeout = timeout + 1
		if timeout >= CONNECTION_TIMEOUT then
			errorDialog.msg = string.format(ERR_TIMEOUT_CONNECTING, XBOX_IP_ADDRESS, XBOX_SERVER_PORT)
			socket:close()
			return nil
		end
	end
	if parameters and parameters ~= "" then
		params = string.gsub(parameters,"%%","%%25")
		params = string.gsub(params," ","%%20")
		params = string.gsub(params,"&","%%26")
		params = string.gsub(params,"+","%%2B")
	else
		params = ""
	end
	socket:send("GET /xbmcCmds/xbmcHttp?command=" .. command .. "&parameter=" .. params .. " HTTP/1.0\r\n")
	if authorization then
		socket:send("Authorization: Basic " .. authorization .. "\r\n")
	end
	socket:send("host: " .. ipAddress .. "\r\n\r\n")
	if nowait then
		timeout = 0
		while true do
			System.sleep(1)
			timeout = timeout + 1
				if timeout >= DATA_TIMEOUT then
					socket:close()
					return nil
				end
			tmp = socket:recv()
				if string.len(tmp) > 0 then
					socket:close()
					return nil
				end
		end
	end
	timeout = 0
	buffer = ""
	while true do
		if yield then
			coroutine.yield()
		else
			System.sleep(1)
		end
		timeout = timeout + 1
		if timeout >= DATA_TIMEOUT then
			errorDialog.msg = ERR_TIMEOUT_DATA
			socket:close()
			return nil
		end
		tmp = socket:recv()
		if string.len(tmp) > 0 then
			timeout = 0
			buffer = buffer .. tmp
			foe, eof = string.find(buffer,"</html>")
			if eof then
				break
			end
		end
	end
	if string.find(buffer,"401 Unauthorized") then
		errorDialog.msg = ERR_UNAUTHORIZED
		return nil
	end
	socket:close()
	s = string.find(buffer,"<html>")
	e = string.find(buffer,"</html>",s)
		if not s then
			return nil
		end
	if string.find(buffer,"Error: could not get location",-300) then
		errorDialog.msg = string.format(ERR_NO_LOCATION, string.sub(parameters,-40))
		return nil
	end
	if string.find(buffer,"Error:Unknown command",-40) then
		errorDialog.msg = string.format(ERR_UNKNOWN_COMMAND, command)
		return nil
	end
	errorDialog.msg = nil
	return string.gsub(string.sub(buffer,s+6,e-1),"[\r\n]","")
end
function inputControl()
	pad = Controls.read()
	if (pad == oldPad) or (repeatDelay:time() >= REPEAT_DELAY) then
		if errorDialog.msg then
			if pad:cross() then
				errorDialog.msg = nil
			end
		elseif background.activeControl == networkConnections then
			selectNetworkControl(pad)
		elseif background.activeControl == remoteControl then
			RemoteControl(pad)
		elseif background.activeControl == playLists then
			selectPlayLists(pad)
		elseif background.activeControl == buttons then
			buttonControl(pad)
		elseif background.activeControl == itemList then
			itemListControl(pad)
		end
		if pad:l() and pad:right() then
			playNext()
		elseif pad:l() and pad:left() then
			playPrev()
		elseif pad:start() then
		    background.activeControl = remoteControl
		elseif pad:square() then
			XbmcStopPlaying()
		elseif pad:triangle() then
			XbmcPausePlaying()
		elseif pad:circle() then
			XbmcGetMedialocation()
		elseif pad:r() then
			if buttons.active == browsebtns then
				flexrecall = flex
				flex = flex + 1
				flextype()
			end
		elseif pad:analogY() <= -30 or pad:analogY() >= 30 then
			setVolume(pad:analogY())
		elseif pad:analogX() then
			setPlaySpeed(pad:analogX())
		end
	end
	if pad == oldPad then
		repeatDelay:reset(REPEAT_DELAY-REPEAT_RATE)
	else
		repeatDelay:reset()
	end
	oldPad = pad
	repeatDelay:start()
end
function buttonControl(pad)
	if pad:up() and not pad:l() then
		moveActive(buttons.active, -1)
	elseif pad:down() and not pad:l() then
		moveActive(buttons.active, 1)
	elseif pad:right() and not pad:l() then
		background.activeControl = itemList
	elseif browsebtns.active == SHUTDOWN_BTN then
		if pad:l() and pad:up() then
			cap_num = cap_num - 1
			extendedcontrol()
		elseif pad:l() and pad:down() then
			cap_num = cap_num + 1
			extendedcontrol()
		elseif pad:cross() then
      		pressed = 1
			extendedcontrol()
		end
	elseif pad:l() and pad:cross() then
		XbmcGetCurrentlyPlaying()
	elseif pad:cross() and not pad:l() then
		if playList.active then
			if playlistbtns.active == RANDOMIZE_BTN then
				playList.randomized = not playList.randomized
			elseif playlistbtns.active == LOAD_BTN then
				enumePlayLists()
			elseif playlistbtns.active == SAVE_BTN then
				enumePlayLists()
			elseif playlistbtns.active == CLEAR_BNT then
				clearPlayList()
			end
		else
			if browsebtns.active == SORT_BTN then
				itemList.sortAsc = not itemList.sortAsc
				if itemList.count > 0 then
					sortItemList(itemList.items[itemList.active+1].name,itemList.active-itemList.topItem)
				end
			elseif browsebtns.active == PLAYLIST_BTN and flex == 0 then
				XbmcGetMedialocation("playlist")
			elseif browsebtns.active == PLAYDVD_BTN then
				Xbmcplaydvd()
			end
		end
	end
end
function itemListControl(pad)
	if itemList.count > 0 then
		if pad:up() then
			moveActive(itemList, -1)
		elseif pad:down() then
			moveActive(itemList, 1)
		elseif pad:l() and pad:cross() then
			XbmcGetCurrentlyPlaying()
		elseif pad:cross() and not pad:l() then
			if itemList.items[itemList.active+1].isDir then
				XbmcGetMedialocation(itemList.items[itemList.active+1].path)
			else
				XbmcPlayFile()
			end
		elseif pad:select() then
			if playList.active then
				deleteFromPlayList(itemList.active)
				elseif flex == 0 then
					addToPlayList(itemList.items[itemList.active+1])
					moveActive(itemList, 1)
			end
		end
	end
	if pad:left() and not pad:l()  then
		background.activeControl = buttons
	end
end
function selectNetworkControl(pad)
	if pad:up() then
		moveActive(networkConnections, -1)
	elseif pad:down() then
		moveActive(networkConnections, 1)
	elseif pad:cross() then
		if networkConnections.items[networkConnections.active+1].idx > 0 then
			if connectToWlan() then
				if XbmcGetMedialocation("") then
					background.activeControl = buttons
					XbmcGetCurrentlyPlaying()
				end
			end
		end
	end
end
function selectPlayLists(pad)
	if pad:up() then
		moveActive(playLists, -1)
	elseif pad:down() then
		moveActive(playLists, 1)
	elseif pad:cross() then
		if playlistbtns.active == LOAD_BTN then
			loadPlayList(playLists.items[playLists.active+1].filename)
		else
			savePlayList(playLists.items[playLists.active+1].filename)
		end
	background.activeControl = buttons
	elseif pad:circle() then
		background.activeControl = buttons
	end
end
function RemoteControl(pad)
	if pad:analogY() < -30 then
		if pad:analogX() < 30 then
			remoteControl.selectet = 0
		else
			remoteControl.selectet = 1
		end
	else
		remoteControl.selectet = nil
	end
	if pad:l() and pad:r() then
		background.activeControl = buttons
	elseif pad:up() then
		XbmcSendKey(270)
	elseif pad:down() then
		XbmcSendKey(271)
	elseif pad:left() then
		XbmcSendKey(272)
	elseif pad:right() then
		XbmcSendKey(273)
	elseif pad:cross() then
		if remoteControl.selectet == 0 then
			XbmcSendKey(261)
		elseif remoteControl.selectet == 1 then
			XbmcSendKey(260)
		else
			XbmcSendKey(256)
		end
	elseif pad:circle() then
		XbmcSendKey(257)
	elseif pad:square() then
		XbmcSendKey(258)
	elseif pad:triangle() then
		XbmcSendKey(259)
	elseif pad:l() then
		XbmcSendKey("278;255")
	elseif pad:r() then
		XbmcSendKey("279;0;255")
	elseif pad:start() then
		XbmcSendKey(274)
	elseif pad:select() then
		XbmcSendKey(275)
	end
end
function extendedcontrol()
	if cap_num > 2 then
		cap_num = 2
	end
	if cap_num < 1 then
		cap_num = 1
	end
	if cap_num == 1 then
		browsebtns.captions[4] = "Shutdown"
		switch = 0
		if pressed == 1 then
			XbmcStopPlaying()
			XbmcHttpApi("shutdown",false,false,true)
		end
	else
		browsebtns.captions[4] = "Restart Xbox"
		switch = 1
		if pressed == 1 then
			XbmcStopPlaying()
			XbmcHttpApi("Reset",false,false,true)
		end
	end	
	pressed = 0
end
function drawBackground()
	screen:blit(0, 0, background.image, 0, 0, 480, 272, false)
	if flex == 2 then
		screen:blit(0, 0, background.vimage, 0, 0, 480, 52, false)
	elseif flex == 0 then
		screen:blit(0, 0, background.mimage, 0, 0, 480, 52, false)
	else
		screen:blit(0, 0, background.pimage, 0, 0, 480, 52, false)
	end
end
function drawButtons()
	local addon = ""
	if playList.active then
		buttons.active = playlistbtns
	else
		buttons.active = browsebtns
	end
	for i = 0, buttons.active.count-1 do
		if (i == buttons.active.active) and (background.activeControl == buttons) then
			screen:blit(10, 60+21*i, buttons.aImage, 0, 0, 110, 20, true)
		else
			screen:blit(10, 60+21*i, buttons.iImage, 0, 0, 110, 20, true)
		end
		if (buttons.active == browsebtns) then
			if (i == SORT_BTN) then
				if itemList.sortAsc then
					n = 0
				else
					n = 1
				end
			screen:blit(107, 64+21*i, buttons.cImage, n*24/2, 0, 24/2, 12, true)	
			elseif (i == PLAYLIST_BTN) then
				if playList.count > 0 then
					addon = string.format(" (%d)",playList.count)
				end
				screen:fontPrint(bigFont, 20, 73+21*i, buttons.active.captions[i+1] .. addon, textColor)
			elseif (i == SHUTDOWN_BTN) then
				if switch == 0 then
					n = 1
				else
					n = 0
				end
			screen:blit(110, 64+21*i, buttons.tImage, n*16/2, 0, 16/2, 8, true)	
			end
		else
			if (i == RANDOMIZE_BTN) then
				if playList.randomized then
					n = 0
				else
					n = 1
				end
				screen:blit(104, 64+21*i, buttons.cImage, n*24/2, 0, 24/2, 12, true)
			end
		end
	screen:fontPrint(bigFont, 20, 73+21*i, buttons.active.captions[i+1], textColor)
	end
end
function drawItemList()
	for i = 0, itemList.lines-1 do
		if itemList.topItem+i < itemList.count then
			if (i == itemList.active-itemList.topItem) and (background.activeControl == itemList) then
				if background.activeControl == itemList then
					screen:blit(142, 61+16*i, itemList.aImage)
				end
				drawItem(itemList.items[itemList.topItem+i+1], 142, 61+16*i, screen)
			else
				match, free = getTmpImage(itemList.topItem+i+1)
				if not match  then
					match = free
					itemList.tmpImg[match].idx = itemList.topItem+i+1
					itemList.tmpImg[match].img:blit(0, 0, background.image, 142, 63, 327, 16, false)
					drawItem(itemList.items[itemList.topItem+i+1], 0, 0, itemList.tmpImg[match].img)
				end
				screen:blit(142,61+16*i, itemList.tmpImg[match].img, 0, 0, 327, 16, true)
			end
		else
			break
		end
	end
	if itemList.count == 1 then
		screen:fontPrint(smallFont, 320, 262, itemList.count .. " Object", textColor)
	else
		screen:fontPrint(smallFont, 320, 262, itemList.count .. " Objects", textColor)
	end
	screen:fontPrint(bigFont, 420, 262, math.floor(itemList.active/itemList.lines)+1 .. "/" .. math.floor(itemList.count/itemList.lines)+1, textColor)
end
function drawItem(item, x, y, image)
	if item.isDir or SHOW_MEDIA_EXTENSION then
		str = item.name
	else
		str = string.gsub(item.name,"%.[^%.]*$","")
	end
	if item.isDir then
		image:blit(x+3, y+2, itemList.folderImg, (image==screen))
	else
		image:blit(x+3, y+2, itemList.audioImg, (image==screen))
	end
	if image ~= screen then
		image:fontPrint(smallFont, x+18, y+12, str, textColor)
	else
		if itemList.idx ~= itemList.active then
			itemList.idx= itemList.active
			itemList.scroll = 0
			itemList.scrollImage:clear(Color.new(119, 124, 122))
			itemList.scrollImage:fontPrint(smallFont, 0, 9, str, textColor)
			i = 0
			itemList.scrollLength = 309
			for x = 309, 511 do
				color = itemList.scrollImage:pixel(x, 7)
				colors = color:colors()
				if colors.r > 120 then
					i = 0
				else
					i = i + 1
					if i > 20 then
						itemList.scrollLength = x - 20
						break
					end
				end
			end
		end
		l = 309
		if itemList.scrollLength-itemList.scroll < 309 then
			l = itemList.scrollLength-itemList.scroll
			if l == 20 then
				itemList.scroll = 0
			end
		end
		image:blit(x+18,y+3,itemList.scrollImage, itemList.scroll, 0, l, 12, true)
		if l < 289 then	
			image:blit(x+38+l,y+3,itemList.scrollImage, 0, 0, 289-l, 12, true)
		end
		if itemList.scrollLength > 309 then
			itemList.scroll = itemList.scroll +1
		end
	end
end
function drawSelectNetwork()
	if background.activeControl == networkConnections then
		screen:blit(90, 36, networkConnections.bgImage, 0, 0, 300, 200, true)
		screen:fontPrint(bigFont, 130, 66, "Network connections", textColor)
		for i = 0, networkConnections.lines-1 do
			if networkConnections.topItem+i < networkConnections.count then
				if (i == networkConnections.active-networkConnections.topItem) then
					screen:blit(133, 96+(networkConnections.aImage:height())*i, networkConnections.aImage, 0, 0, 230, 20, true)
				end
				screen:fontPrint(bigFont, 140, 111+(networkConnections.aImage:height())*i, networkConnections.items[networkConnections.topItem+i+1].name, textColor)
			else
				break
			end
		end
	end
end;
function drawCurrentlyPlaying()
	if currentlyPlaying.values["Type"] then
		if currentlyPlaying.image then
			screen:blit(20, 160, currentlyPlaying.image, 0, 0, 75, 75, true)
		else
			screen:blit(20, 160, currentlyPlaying.defaultImage, 0, 0, 75, 75, true)
		end
		if currentlyPlaying.values["Time"] then
			screen:fontPrint(bigFont, 20, 247, millisecondsToTime(currentlyPlaying.time:time()), textColor)
		end
		if currentlyPlaying.scrollWait >= 30 then
			currentlyPlaying.scroll = math.mod(currentlyPlaying.scroll+481,480)
			restart = true
			for x = 0, 20 do
				color = currentlyPlaying.scrollImage:pixel(x, 6)
				colors = color:colors()
				if colors.r > 100 then
					restart = false
					break
				end
			end
			if restart then
				sector = sector + 1
				if sector > 5 then
					sector = 1
				end
				currentlyPlaying.scrollWait = 0
			end
		else
			currentlyPlaying.scrollWait = currentlyPlaying.scrollWait +1
			currentlyPlaying.scroll = 0
		end
		str = ""
		exsist = 0
		if sector == 1 then
			if currentlyPlaying.values["Title"] then
				str = str .. currentlyPlaying.values["Title"]
			else
				exsist = exsist + 1
				sector = 2
			end
		end
    	if sector == 2 then
    		if currentlyPlaying.values["Artist"] then
    			str = str .. currentlyPlaying.values["Artist"]
    		else
    			exsist = exsist + 1
    			sector = 3
    		end
    	end
    	if sector == 3 then
    		if currentlyPlaying.values["Album"] then
				str = str .. currentlyPlaying.values["Album"]
			else
				exsist = exsist + 1
				sector = 4
			end
		end
		if sector == 4 then
			if currentlyPlaying.values["Genre"] then
				str = str .. currentlyPlaying.values["Genre"]
			else
				exsist = exsist + 1
				sector = 5
			end
		end
		if sector == 5 then
			if currentlyPlaying.values["Year"] then
				str = str .. currentlyPlaying.values["Year"]
			else
				exsist = exsist + 1
			end
		end
    	if (currentlyPlaying.values["Type"] == "Picture")  then
			currentlyPlaying.values["Filename"] =  extractFileNameSMB(currentlyPlaying.values["Filename"])
			if not SHOW_MEDIA_EXTENSION then
				currentlyPlaying.values["Filename"] =	string.gsub(currentlyPlaying.values["Filename"],"%.[^%.]*$","")
			end
			str = str .. currentlyPlaying.values["Filename"]
		end
    	if (currentlyPlaying.values["Title"] == "VIDEO_TS.IFO") then
    		currentlyPlaying.values["Title"] = "Playing DVD"
    		str = str .. currentlyPlaying.values["Title"]
    	end
    	if exsist == 5 then
    			str = str .. currentlyPlaying.values["Filename"]
    	end
		currentlyPlaying.scrollImage:blit(0,0,background.image,20,251,120,10)
		currentlyPlaying.scrollImage:fontPrint(smallFont, -currentlyPlaying.scroll, 8, str, textColor)
		screen:blit(20,251,currentlyPlaying.scrollImage, 0, 0, 120, 10, true)
	end
end
function drawSelectPlayList()
	if background.activeControl == playLists then
		screen:blit(90, 36, networkConnections.bgImage, 0, 0, 300, 200, true)
		if playlistbtns.active == LOAD_BTN then
			screen:fontPrint(bigFont, 130, 60, "Load playlist", textColor)
		else
			screen:fontPrint(bigFont, 130, 60, "Save playlist", textColor)
		end
		for i = 0, playLists.lines-1 do
			if playLists.topItem+i < playLists.count then
				if (i == playLists.active-playLists.topItem) then
					screen:blit(133, 91+20*i, networkConnections.aImage, 0, 0, 230, 20, true)
				end
					screen:fontPrint(bigFont, 140, 106+20*i, playLists.items[playLists.topItem+i+1].name, textColor)
			else
				break
			end
		end
	end
end;
function drawError()
	if errorDialog.msg then
		screen:blit(35, 55, errorDialog.image, 0, 0, 400, 181, true)
		screen:fontPrint(bigFont, 380, 206, "Ok", textColor)
		strings = split2(errorDialog.msg,"\n")
		for i, str in strings do
			if i ~= "n" then
				screen:fontPrint(bigFont, 60, 75+14*i, str, textColor)
			end
		end
	end
end
function drawBrowse()
	drawBackground()
	if background.activeControl ~= networkConnections then
		drawButtons()
		drawItemList()
		drawCurrentlyPlaying()
	end
end
function drawRemoteControl()
	screen:blit(0, 0, remoteControl.image, 0, 0, 480, 272, false)
	if remoteControl.selectet == 0 then
		screen:blit(350, 50, remoteControl.wImage, 0, 0, 20, 20, false)
	elseif remoteControl.selectet == 1 then
		screen:blit(360, 65, remoteControl.bImage, 0, 0, 25, 25, false)
	end
end
function draw()
	if background.activeControl == remoteControl then
		drawRemoteControl()
	else
		drawBrowse()
	end
end
background.image = Image.load(MEDIA_DIR .. "background.png")
background.pimage = Image.load(MEDIA_DIR .. "pictures.png")
background.vimage = Image.load(MEDIA_DIR .. "videos.png")
background.mimage = Image.load(MEDIA_DIR .. "music.png")
buttons.aImage = Image.load(MEDIA_DIR .. "button-focus.png")
buttons.iImage = Image.load(MEDIA_DIR .. "button-nofocus.png")
buttons.tImage = Image.load(MEDIA_DIR .. "toggle.png")
buttons.cImage = Image.load(MEDIA_DIR .. "checkbox.png")
itemList.folderImg = Image.load(MEDIA_DIR .. "folder.png")
itemList.audioImg = Image.load(MEDIA_DIR .. "file.png")
itemList.aImage = Image.load(MEDIA_DIR .. "list-focus.png")
for i = 1, itemList.lines do
	p = {img, idx}
	p.img = Image.createEmpty(330, 16)
	itemList.tmpImg[i] = p
end
networkConnections.bgImage = Image.load(MEDIA_DIR .. "dialog.png")
networkConnections.aImage = Image.load(MEDIA_DIR .. "list-focus2.png")
currentlyPlaying.defaultImage = Image.load(MEDIA_DIR .. "cover.png")
remoteControl.image = Image.load(MEDIA_DIR .. "controller.png")
remoteControl.wImage = Image.load(MEDIA_DIR .. "white.png")
remoteControl.bImage = Image.load(MEDIA_DIR .. "black.png")
errorDialog.image = Image.load(MEDIA_DIR .. "error-dialog.png")
if XBOX_PASSWORD and XBOX_PASSWORD ~= "" then
	authorization = encodeB64(XBOX_USERNAME .. ":" .. XBOX_PASSWORD)
end
ipAddress = nil
math.randomseed(os.time())
repeatDelay = Timer.new()
Wlan.term()
Wlan.init()
configs = Wlan.getConnectionConfigs()
	for key, value in configs do
		networkConnections.items[key] = {name = value, idx = key }
		networkConnections.count = key
	end
	if networkConnections.count == 0 then
		errorDialog.msg = ERR_NO_CONNECTIONS_FOUND
	else
		background.activeControl = networkConnections
	end
while true do
	inputControl()
	corutineHandler()
    draw()
	drawSelectNetwork()
	drawSelectPlayList()
	drawError()
	screen.waitVblankStart()
	screen.flip()
end
Wlan.term()
